(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-hpc")

(document:envelop with-attributes
                  (password1 password2))

(document:envelop with-container-presentations
                  ((password-box '/users/passwd)))

;;; Functions

(define (write-ldap)
  (woo-catch/message
   (thunk
    (let ((basedn (ldap_basedn text))
          (rootdn (ldap_rootdn text))
          (rootpw1 (ldap_rootpw password1))
          (rootpw2 (ldap_rootpw password2)))
      (cond
       ((string-null? basedn)
        (woo-throw (_ "You should define Base DN")))
       ((string-null? rootdn)
        (woo-throw (_ "You should define Root DN")))
       ((or (string-null? rootpw1) (string-null? rootpw2))
        (woo-throw (_ "You should define an administrator password")))
       ((not (string=? rootpw1 rootpw2))
        (woo-throw (_ "Passwords mismatch")))
       (else
        ;;setup server
        (woo-write "/hpc-ldap"
                   'ldap_basedn basedn
                   'ldap_rootdn rootdn
                   'ldap_rootpw rootpw1)))))))

;;; UI

(gridbox
 columns "20;60;20"

 (spacer)
 (hbox (label (_ "Base DN"))
       (document:id ldap_basedn (edit "")))
 (spacer)
 
 (spacer)
 (spacer)
 (spacer)
 
 (spacer)
 (separator)
 (spacer)
 
 (spacer)
 (spacer)
 (spacer)
 
 (spacer)
 (hbox (label (_ "Administrator DN"))
       (document:id ldap_rootdn (edit "")))
 (spacer)

 (spacer)
 (groupbox (_ "Administrator password")
           (document:id ldap_rootpw (password-box)))
 (spacer))

(frame:on-next (thunk (or (write-ldap) 'cancel)))

;;; Logic

(document:root (when loaded
                 (woo-catch/message
                  (thunk
                   (woo-try "init" "/hpc-ldap")
                   (let ((data (woo-read-first "/hpc-ldap")))
                     (ldap_basedn text (woo-get-option data 'ldap_basedn))
                     (ldap_rootdn text (woo-get-option data 'ldap_rootdn)))))))
